! Generates the data of Figure 3 (b)
! Run: $ gfortran Parameters2.f90 fig_3b.f90; ./a.out
!
! Author: Michele Mugnaine
! Execution time:
! Last modified: 27/06/2023
!__________________________________________________________________
PROGRAM MAIN
  USE PARAMETERS2
  IMPLICIT NONE
  REAL*8::t0,t,phi,f,theta0,I0,thetan,In,xn
  INTEGER:: k,n
  !---------------------------------------------------------------
  OPEN(1,FILE='IC_3b.dat', STATUS="OLD")
  OPEN(2,FILE='Data_3b.dat',STATUS="UNKNOWN")
  !---------------------------------------------------------------
  ! Initial Conditions
  DO k=1,nmax
     READ(1,*) theta0,I0
     t0=0;t=0.0
     DO n=1,nfinal
        t=t0+h
        !
        ! Function f(\phi) - equation (51)
        phi=MOD(t,2.0*pi)
        IF(phi.GE.0.0.AND.phi.LT.xi) THEN
           f=1.0
        ELSE IF(phi.GE.xi.AND.phi.LT.2.0*pi) THEN
           f=0.0
        END IF
        !
        CALL NewtonRhapson(theta0,I0,f,xn) ! Obtain the value of \theta_{n+1}
        thetan=MOD(xn,2.0*pi) !\theta_{n+1}
        !
        IF(thetan.LT.0.0) thetan=thetan+2.0*pi
        !
        In=I0-2.0*h*m*eps*SIN(m*thetan)*I0**(m/2.0)*f
        !
        ! Poincare section at \phi=0
        IF(ABS(phi).LT.1E-3.AND.In.LE.1.0) WRITE(2,*) thetan,In
        !
        theta0=thetan; I0=In; t0=t
     END DO
  END DO
!        
CONTAINS
!
  SUBROUTINE NewtonRhapson(x0,I0,f,xn)
    IMPLICIT NONE
    REAL*8::y0,x0,fx,y,xn,I0,f
    INTEGER::i
    !-------------------------------------------------------------
    y0=x0
    !
20  DO i=1,ifinal
       fx=y0-x0-h*(1.0-I0/2.0-eps*m*COS(m*y0)*I0**(m/2.0-1.0)*f)
       y=y0-fx/(1.0-h*eps*m**2.0*SIN(m*y0)*I0**(m/2.0-1.0)*f)
       !
       IF(ABS(y-y0).LT.TOL) THEN
          xn=y
          EXIT
       ELSE IF(i.EQ.ifinal.AND.ABS(y-y0).GT.TOL) THEN
          !Not enough iterations
          GO TO 20
       END IF
       y0=y
    END DO
  END SUBROUTINE NewtonRhapson

END PROGRAM MAIN
  
